=== added file 'NEWS.developers'
--- NEWS.developers	1970-01-01 00:00:00 +0000
+++ NEWS.developers	2005-09-19 07:52:30 +0000
@@ -0,0 +1,7 @@
+changes in weave branch:
+
+ * Remove RevisionReference class; Revision.parents is now simply a
+   list of their ids and parent_sha1s  is a list of their
+   corresponding sha1s (for old branches only at the moment.)
+
+

=== modified file 'bzrlib/check.py'
--- bzrlib/check.py	2005-09-16 07:50:36 +0000
+++ bzrlib/check.py	2005-09-19 07:52:30 +0000
@@ -120,36 +120,16 @@
                     raise BzrCheckError("revision {%s} has %d parents, but is the "
                                         "start of the branch"
                                         % (rev_id, len(rev.parents)))
-                for prr in rev.parents:
-                    if prr.revision_id == last_rev_id:
+                for parent_id in rev.parents:
+                    if parent_id == last_rev_id:
                         break
                 else:
                     raise BzrCheckError("previous revision {%s} not listed among "
                                         "parents of {%s}"
                                         % (last_rev_id, rev_id))
-
-                for prr in rev.parents:
-                    if prr.revision_sha1 is None:
-                        missing_revision_sha_cnt += 1
-                        continue
-                    prid = prr.revision_id
-                    
-                    try:
-                        actual_sha = branch.get_revision_sha1(prid)
-                    except NoSuchRevision:
-                        missing_revision_cnt += 1
-                        mutter("parent {%s} of {%s} not present in store",
-                               prid, rev_id)
-                        continue
-                        
-                    if prr.revision_sha1 != actual_sha:
-                        raise BzrCheckError("mismatched revision sha1 for "
-                                            "parent {%s} of {%s}: %s vs %s"
-                                            % (prid, rev_id,
-                                               prr.revision_sha1, actual_sha))
             elif last_rev_id:
-                raise BzrCheckError("revision {%s} has no parents listed but preceded "
-                                    "by {%s}"
+                raise BzrCheckError("revision {%s} has no parents listed "
+                                    "but preceded by {%s}"
                                     % (rev_id, last_rev_id))
 
             ## TODO: Check all the required fields are present on the revision.

=== modified file 'bzrlib/commit.py'
--- bzrlib/commit.py	2005-09-16 09:43:55 +0000
+++ bzrlib/commit.py	2005-09-19 07:52:30 +0000
@@ -67,7 +67,7 @@
 from bzrlib.errors import (BzrError, PointlessCommit,
                            HistoryMissing,
                            )
-from bzrlib.revision import Revision, RevisionReference
+from bzrlib.revision import Revision
 from bzrlib.trace import mutter, note, warning
 from bzrlib.xml5 import serializer_v5
 from bzrlib.inventory import Inventory
@@ -286,7 +286,7 @@
                             message=self.message,
                             inventory_sha1=self.inv_sha1,
                             revision_id=self.rev_id)
-        self.rev.parents = map(RevisionReference, self.parents)
+        self.rev.parents = self.parents
         rev_tmp = StringIO()
         serializer_v5.write_revision(self.rev, rev_tmp)
         rev_tmp.seek(0)

=== modified file 'bzrlib/fetch.py'
--- bzrlib/fetch.py	2005-09-15 09:04:42 +0000
+++ bzrlib/fetch.py	2005-09-19 07:52:30 +0000
@@ -176,9 +176,8 @@
                rev.committer,
                len(rev.parents))
         self._copy_new_texts(rev_id, inv)
-        parent_ids = [x.revision_id for x in rev.parents]
-        self._copy_inventory(rev_id, inv_xml, parent_ids)
-        self._copy_ancestry(rev_id, parent_ids)
+        self._copy_inventory(rev_id, inv_xml, rev.parents)
+        self._copy_ancestry(rev_id, rev.parents)
         self.to_branch.revision_store.add(StringIO(rev_xml), rev_id)
 
 

=== modified file 'bzrlib/log.py'
--- bzrlib/log.py	2005-09-05 05:35:25 +0000
+++ bzrlib/log.py	2005-09-19 07:52:30 +0000
@@ -310,8 +310,8 @@
         if self.show_ids:
             print >>to_file,  'revision-id:', rev.revision_id
 
-            for parent in rev.parents:
-                print >>to_file, 'parent:', parent.revision_id
+            for parent_id in rev.parents:
+                print >>to_file, 'parent:', parent_id
             
         print >>to_file,  'committer:', rev.committer
 

=== modified file 'bzrlib/revision.py'
--- bzrlib/revision.py	2005-09-16 04:47:12 +0000
+++ bzrlib/revision.py	2005-09-19 07:52:30 +0000
@@ -18,30 +18,6 @@
 import bzrlib.errors
 
 
-class RevisionReference(object):
-    """
-    Reference to a stored revision.
-
-    Includes the revision_id and revision_sha1.
-    """
-    revision_id = None
-    revision_sha1 = None
-    def __init__(self, revision_id, revision_sha1=None):
-        if revision_id == None \
-           or isinstance(revision_id, basestring):
-            self.revision_id = revision_id
-        else:
-            raise ValueError('bad revision_id %r' % revision_id)
-
-        if revision_sha1 != None:
-            if isinstance(revision_sha1, basestring) \
-               and len(revision_sha1) == 40:
-                self.revision_sha1 = revision_sha1
-            else:
-                raise ValueError('bad revision_sha1 %r' % revision_sha1)
-                
-
-
 class Revision(object):
     """Single revision on a branch.
 
@@ -65,6 +41,7 @@
     def __init__(self, **args):
         self.__dict__.update(args)
         self.parents = []
+        self.parent_sha1s = []
 
 
     def __repr__(self):
@@ -128,7 +105,7 @@
                     continue
             if only_present:
                 yield ancestor, distance
-            new_ancestors.extend([p.revision_id for p in revision.parents])
+            new_ancestors.extend(revision.parents)
         ancestors = new_ancestors
         distance += 1
 
@@ -234,9 +211,7 @@
     while len(active) > 0:
         new_active = []
         for line in active:
-            parent_ids = [p.revision_id for p in 
-                          rev_source.get_revision(line[-1]).parents]
-            for parent in parent_ids:
+            for parent in rev_source.get_revision(line[-1]).parents:
                 line_copy = line[:]
                 if parent == ancestor_id:
                     successful_lines.append(line_copy)

=== modified file 'bzrlib/selftest/test_xml.py'
--- bzrlib/selftest/test_xml.py	2005-09-16 09:43:55 +0000
+++ bzrlib/selftest/test_xml.py	2005-09-19 07:52:30 +0000
@@ -92,7 +92,7 @@
         eq(rev.inventory_id,
            "mbp@sourcefrog.net-20050905080035-e0439293f8b6b9f9")
         eq(len(rev.parents), 1)
-        eq(rev.parents[0].revision_id,
+        eq(rev.parents[0],
            "mbp@sourcefrog.net-20050905063503-43948f59fa127d92")
 
     def test_unpack_revision_5(self):
@@ -104,7 +104,7 @@
            "Martin Pool <mbp@sourcefrog.net>")
         eq(len(rev.parents), 1)
         eq(rev.timezone, 36000)
-        eq(rev.parents[0].revision_id,
+        eq(rev.parents[0],
            "mbp@sourcefrog.net-20050905063503-43948f59fa127d92")
 
     def test_unpack_inventory_5(self):

=== modified file 'bzrlib/xml.py'
--- bzrlib/xml.py	2005-09-16 09:14:43 +0000
+++ bzrlib/xml.py	2005-09-19 07:52:30 +0000
@@ -35,7 +35,6 @@
                                               fromstring, tostring)
 
 from bzrlib.inventory import ROOT_ID, Inventory, InventoryEntry
-from bzrlib.revision import Revision, RevisionReference        
 from bzrlib.errors import BzrError
 
 

=== modified file 'bzrlib/xml4.py'
--- bzrlib/xml4.py	2005-09-16 09:14:43 +0000
+++ bzrlib/xml4.py	2005-09-19 07:52:30 +0000
@@ -17,7 +17,7 @@
 
 from bzrlib.xml import ElementTree, SubElement, Element, Serializer
 from bzrlib.inventory import ROOT_ID, Inventory, InventoryEntry
-from bzrlib.revision import Revision, RevisionReference        
+from bzrlib.revision import Revision        
 from bzrlib.errors import BzrError
 
 
@@ -129,15 +129,13 @@
         if rev.parents:
             pelts = SubElement(root, 'parents')
             pelts.tail = pelts.text = '\n'
-            for rr in rev.parents:
-                assert isinstance(rr, RevisionReference)
+            for i, parent_id in enumerate(rev.parents):
                 p = SubElement(pelts, 'revision_ref')
                 p.tail = '\n'
-                assert rr.revision_id
-                p.set('revision_id', rr.revision_id)
-                if rr.revision_sha1:
-                    p.set('revision_sha1', rr.revision_sha1)
-
+                assert parent_id
+                p.set('revision_id', parent_id)
+                if i < len(rev.parent_sha1s):
+                    p.set('revision_sha1', rev.parent_sha1s[i])
         return root
 
     
@@ -164,10 +162,8 @@
             for p in pelts:
                 assert p.tag == 'revision_ref', \
                        "bad parent node tag %r" % p.tag
-                rev_ref = RevisionReference(p.get('revision_id'),
-                                            p.get('revision_sha1'))
-                rev.parents.append(rev_ref)
-
+                rev.parents.append(p.get('revision_id'))
+                rev.parent_sha1s.append(p.get('revision_sha1'))
             if precursor:
                 # must be consistent
                 prec_parent = rev.parents[0].revision_id
@@ -175,8 +171,8 @@
         elif precursor:
             # revisions written prior to 0.0.5 have a single precursor
             # give as an attribute
-            rev_ref = RevisionReference(precursor, precursor_sha1)
-            rev.parents.append(rev_ref)
+            rev.parents.append(precursor)
+            rev.parent_sha1s.append(precursor_sha1)
 
         v = elt.get('timezone')
         rev.timezone = v and int(v)

=== modified file 'bzrlib/xml5.py'
--- bzrlib/xml5.py	2005-09-16 09:43:55 +0000
+++ bzrlib/xml5.py	2005-09-19 07:52:30 +0000
@@ -17,7 +17,7 @@
 
 from bzrlib.xml import ElementTree, SubElement, Element, Serializer
 from bzrlib.inventory import ROOT_ID, Inventory, InventoryEntry
-from bzrlib.revision import Revision, RevisionReference        
+from bzrlib.revision import Revision        
 from bzrlib.errors import BzrError
 
 
@@ -89,13 +89,11 @@
         if rev.parents:
             pelts = SubElement(root, 'parents')
             pelts.tail = pelts.text = '\n'
-            for rr in rev.parents:
-                assert isinstance(rr, RevisionReference)
+            for parent_id in rev.parents:
+                assert isinstance(parent_id, basestring)
                 p = SubElement(pelts, 'revision_ref')
                 p.tail = '\n'
-                assert rr.revision_id
-                p.set('revision_id', rr.revision_id)
-
+                p.set('revision_id', parent_id)
         return root
 
     
@@ -149,8 +147,7 @@
         for p in parents:
             assert p.tag == 'revision_ref', \
                    "bad parent node tag %r" % p.tag
-            rev_ref = RevisionReference(p.get('revision_id'))
-            rev.parents.append(rev_ref)
+            rev.parents.append(p.get('revision_id'))
 
         v = elt.get('timezone')
         rev.timezone = v and int(v)

